#--------------------------------------------------------------------------------------------------------
# XCN-InstaGib 2.0.0 by M4rc3L-XCN
# 
# Require: Eventscripts 2.0.250i+
#          ES_Tools 0.420+
#--------------------------------------------------------------------------------------------------------
import es, playerlib, random, popuplib, esamlib, os, string, gamethread, usermsg

def load():
  global XCN_InstaGib
  XCN_InstaGib = "2.0.0"

  ifxcnvar = es.exists('variable','M4rc3L-XCN')
  if ifxcnvar != 1:
    M4rc3L = "XCN-InstaGib"
  else:
    marcel = str(es.ServerVar("M4rc3L-XCN"))
    marstat = marcel.split(",")
    if not "XCN-InstaGib" in marstat:
      M4rc3L = "%s,%s" % (marcel,"XCN-InstaGib")
    else:
      M4rc3L = marcel
  es.set("XCN-InstaGib",XCN_InstaGib)
  es.set("M4rc3L-XCN",M4rc3L)
  es.makepublic("XCN-InstaGib")
  es.makepublic("M4rc3L-XCN")
  global igold_gravity,igold_freezetime,igold_friendlyfire
  igold_gravity = es.ServerVar("sv_gravity")
  igold_freezetime = es.ServerVar("mp_freezetime")
  igold_friendlyfire = es.ServerVar("mp_friendlyfire")
  if not os.path.isfile(es.getAddonPath('xcn_instagib') + '/settings.txt'):
    es.msg("#multi", "#green[XCN-InstaGib]#default settings.txt not found!")
    es.server.queuecmd("es_unload xcn_instagib")
  readcfg()
  gamethread.delayed(7,check_update_available)
  es.server.queuecmd("eventscripts_noisy 1")
  gamethread.delayed(10,reset_map)
  es.msg("#multi","#green[XCN-InstaGib]#default was loaded!")
  global script_loaded
  script_loaded=1
  if es.ServerVar("xcnig_stats") == 1:
    es.sql('open','xcn_instagib_database','|xcn_instagib')
    es.sql('query','xcn_instagib_database',"CREATE TABLE IF NOT EXISTS stats (steamid TEXT,kills INTEGER DEFAULT '0',deaths INTEGER DEFAULT '0')")
    
    nowplayers = playerlib.getPlayerList('#human')
    for nowplayer in nowplayers:
      network_steamid = nowplayer.attributes['steamid']
      check = es.sql('queryvalue','xcn_instagib_database',"SELECT steamid FROM stats WHERE steamid='%s'" % network_steamid)
      if check == None:
        es.sql('query','xcn_instagib_database',"INSERT INTO stats (steamid, kills, deaths) VALUES ('%s', 0, 0)" % network_steamid)
  
  es.server.queuecmd("sv_gravity %s" %es.ServerVar("xcnig_gravity"))
  es.server.queuecmd("mp_freezetime 3.0")
  es.server.queuecmd("mp_friendlyfire 0")
  es.server.queuecmd("eventscripts_noisy 1") 
  display() 
    
    
    
def unload():
  global igold_gravity,igold_freezetime,igold_friendlyfire,script_loaded
  if script_loaded == 1:
    es.server.queuecmd("sv_gravity %s" %igold_gravity)
    es.server.queuecmd("mp_freezetime %s" %igold_freezetime)
    es.server.queuecmd("mp_friendlyfire %s" %igold_friendlyfire)
    es.msg("#multi","#green[XCN-InstaGib]#default was unloaded!")
    if es.ServerVar("xcnig_stats") == 1:
      es.sql('close','xcn_instagib_database')
    script_loaded=0

def readcfg():
    pfad = str(es.getAddonPath('xcn_instagib')) + '/settings.txt'
    if os.path.isfile(pfad):
      cfgfile = open(pfad, 'r')
      cfglines = map(string.strip, cfgfile.readlines())
      cfgfile.close()
      for line in cfglines:
        if not line.startswith('//'):
          if not line.startswith('#'):
            splittedtarray = line.split(' ', 1)
            variable = splittedtarray[0]
            value = splittedtarray[1]
            es.set(variable,value)
            
def reset_map():
  es.server.queuecmd("est_remove func_buyzone")
  es.server.queuecmd("est_remove func_bomb_target")
  es.server.queuecmd("est_remove func_hostage_rescue")
  es.server.queuecmd("est_remove hostage_entity")
  if int(es.ServerVar("xcnig_mapplugin_compatible")) == 1:
    es.server.queuecmd("mani_anti_rejoin 0")

def round_start(ev):
  es.server.queuecmd("est_remove func_buyzone")
  es.server.queuecmd("est_remove func_bomb_target")
  es.server.queuecmd("est_remove func_hostage_rescue")
  es.server.queuecmd("est_remove hostage_entity")

def es_map_start(ev):
  readcfg()
  gamethread.delayed(7,check_update_available)
  gamethread.delayed(10,reset_map)
 
def player_spawn(ev):
  if int(ev['es_userteam']) > 1:
    es.server.queuecmd("est_DropWeapon %s 1" %ev['userid'])
    es.server.queuecmd("est_DropWeapon %s 2" %ev['userid'])
    es.server.queuecmd("est_DropWeapon %s 3" %ev['userid'])
    es.server.queuecmd("est_DropWeapon %s 4" %ev['userid'])
    es.server.queuecmd("est_DropWeapon %s 5" %ev['userid'])
    es.server.queuecmd("es est_removeIdle weapon")
    es.server.queuecmd("es_give %s %s" %(ev['userid'],es.ServerVar("xcnig_gun")))
    rrs_player = playerlib.getPlayer(ev['userid'])
    rrs_player.setHealth(es.ServerVar("xcnig_health"))
    rrs_player.setSpeed(es.ServerVar("xcnig_speed"))
    rrs_player.setCash(0)
    waffenfunktion(ev['userid'])
    es.server.queuecmd("es est_removeIdle weapon")
  
def weapon_fire(ev):
    gamethread.delayed(es.ServerVar("xcnig_switchtime"),waffenfunktion,ev['userid'])
  
def waffenfunktion(userid):
    rrs_player = playerlib.getPlayer(userid)
    if rrs_player.isdead == 0:
      if rrs_player.weapon == es.ServerVar("xcnig_gun"):
        waffe=str(es.ServerVar("xcnig_gun"))
        rrs_player.setAmmo(waffe, 0)
        rrs_player.setClip(waffe, 1)
  
def item_pickup(ev):
  if int(ev['es_userteam']) > 1:
    rrs_player = playerlib.getPlayer(ev['userid'])
    if rrs_player.isdead == 0:
      if rrs_player.weapon == es.ServerVar("xcnig_gun"):
        waffe=str(es.ServerVar("xcnig_gun"))
        rrs_player.setAmmo(waffe, 0)
        rrs_player.setClip(waffe, 0)
        gamethread.delayed(es.ServerVar("xcnig_switchtime"),waffenfunktion,ev['userid'])


def player_team(ev):
  if int(ev['team']) > 1:
    es.tell(ev['userid'],"#multi", "#green[XCN-InstaGib]#default You Spawn in %s Seconds!" %es.ServerVar("xcnig_spawntime"))
    gamethread.delayed(es.ServerVar("xcnig_spawntime"),spawnfunktion,ev['userid'])
  
def player_death(ev):
  if int(ev['es_userteam']) > 1:
    if int(es.ServerVar("xcnig_dissolver")) == 1:
      death_user = ev['userid']
      es.server.queuecmd("es_give %s env_entity_dissolver" %death_user)
      es.server.queuecmd("es_fire %s env_entity_dissolver AddOutput \"target cs_ragdoll\"" %death_user)
      es.server.queuecmd("es_fire %s env_entity_dissolver AddOutput \"magnitude 1\"" %death_user)
      es.server.queuecmd("es_fire %s env_entity_dissolver AddOutput \"dissolvetype 3\"" %death_user)
      es.server.queuecmd("es_fire %s env_entity_dissolver Dissolve" %death_user)
      es.server.queuecmd("es_delayed 1.0 es_remove env_entity_dissolver")
      if es.ServerVar("xcnig_stats") == 1:
        es.sql('query','xcn_instagib_database',"UPDATE stats SET kills = (kills + 1) WHERE steamid='%s'" % ev['es_attackersteamid'])
        es.sql('query','xcn_instagib_database',"UPDATE stats SET deaths = (deaths + 1) WHERE steamid='%s'" % es.getplayersteamid(death_user))
        
  
    es.server.queuecmd("es est_removeIdle weapon")
    es.tell(ev['userid'],"#multi", "#green[XCN-InstaGib]#default You Spawn in %s Seconds!" %es.ServerVar("xcnig_spawntime"))
    gamethread.delayed(es.ServerVar("xcnig_spawntime"),spawnfunktion,ev['userid'])

def spawnfunktion(userid):
  player = playerlib.getPlayer(userid)
  if player.isdead == 1:
    es.server.queuecmd("est_Spawn %s" %userid)


def player_disconnect(event_var):
  if es.ServerVar("xcnig_stats") == 1:
    es.sql('query','xcn_instagib_database',"DELETE FROM stats WHERE steamid='%s'" % event_var['networkid'])
 
def es_player_validated(event_var):
  if es.ServerVar("xcnig_stats") == 1:
    check = es.sql('queryvalue','xcn_instagib_database',"SELECT steamid FROM stats WHERE steamid='%s'" % event_var['networkid'])
    if check == None:
      es.sql('query','xcn_instagib_database',"INSERT INTO stats (steamid, kills, deaths) VALUES ('%s', 0, 0)" % event_var['networkid'])   
    
def display():
  global script_loaded
  if es.ServerVar("xcnig_stats") == 1:
    if script_loaded == 1:
      gamethread.delayed(2, display)
      nowplayers = playerlib.getPlayerList('#human')
      for nowplayer in nowplayers:
        network_steamid = nowplayer.attributes['steamid']
        kills = es.sql('queryvalue','xcn_instagib_database',"SELECT kills FROM stats WHERE steamid='%s'" % network_steamid)
        deaths = es.sql('queryvalue','xcn_instagib_database',"SELECT deaths FROM stats WHERE steamid='%s'" % network_steamid)
        displayz="Player Speed: %s\nKills: %s\nDeaths: %s" %(es.ServerVar("xcnig_speed"),kills,deaths)
        usermsg.hudhint(nowplayer.userid, displayz)

def check_update_available():
  global XCN_InstaGib
  update_available = esamlib.getAddon('XCN-InstaGib')
  new_version = update_available.currentversion
  if not new_version == XCN_InstaGib:
    es.msg("#multi", "#green[XCN-InstaGib]#default Update is available!!! New version is: %s" %new_version)
